/**
 * NOTE: This class is auto generated by the swagger code generator program (1.0.11).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.bigpi.dsp.kemanager.fhe.key.restapi;

import java.util.List;
import java.util.Optional;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.bigpi.dsp.kemanager.fhe.key.models.KeyObject;
import com.bigpi.dsp.kemanager.fhe.key.models.KeyTransfer;
import com.fasterxml.jackson.databind.ObjectMapper;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2018-03-16T11:13:18.135Z")

@Api(value = "fhe", description = "the fhe API")
public interface FheApi {

	String FHE_ALGORITHM = "BLACK_LIST_FULL, BLACK_LIST_HIGH, BLACK_LIST_MEDIUM, BLACK_LIST_LOW"; 
	
	Logger log = LoggerFactory.getLogger(FheApi.class);

    default Optional<ObjectMapper> getObjectMapper() {
        return Optional.empty();
    }

    default Optional<HttpServletRequest> getRequest() {
        return Optional.empty();
    }

    default Optional<String> getAcceptHeader() {
        return getRequest().map(r -> r.getHeader("Accept"));
    }

    @ApiOperation(value = "checking wheither the keys are existed by given requestId and DSAId with specific FHE algorithm model", nickname = "isExistedKey", 
    		notes = "checking a set of keys for FHE Analytic Engine", response = String.class, tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Is Existed key", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/key/isExisted/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "*" }, 
        method = RequestMethod.GET)
    ResponseEntity<String> isExistedKey(@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel);

    @ApiOperation(value = "create key from requestId and DSAId with specific FHE algorithm model", nickname = "createKey", notes = "create a set of keys for FHE Analytic Engine", response = String.class, tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Keys was succesfully created", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/key/create/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "*" }, 
        method = RequestMethod.GET)
    ResponseEntity<String> createKey(@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,@ApiParam(value = "",required=true, 
    		allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel);

    
    @ApiOperation(value = "get key from requestId and DSAId with specific FHE algorithm model", nickname = "getKey", 
    		notes = "retrieving a set of keys using for FHE Analytic Engine", response = KeyTransfer.class, 
    		tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = KeyTransfer.class, responseContainer = "List"),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/key/{KeyType}/get/{RequestId}/dsa/{DSAId}/scheme/{FHEModel}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<KeyTransfer> getKey(
    		@ApiParam(value = "",required=true, allowableValues = "FHE_SECRETKEY, FHE_PUBKEY, FHE_ALL") @PathVariable("KeyType") String keyInfo,
    		@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,
    		@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId,
    		@ApiParam(value = "",required=true, allowableValues = FHE_ALGORITHM) @PathVariable("FHEModel") String fhEModel);
    
    
    
    @ApiOperation(value = "create key from requestId and DSAId transchiffering algorithm ", nickname = "createTransKey", notes = "create of transchiffering key 128it for FHE Analytic Engine", response = String.class, tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = String.class),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/trans/key/create/{RequestId}/dsa/{DSAId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<String> createTransKey(@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId);

    @ApiOperation(value = "get key from requestId and DSAId with specific FHE algorithm model", nickname = "getTransKey", notes = "retrieving a set of keys using for FHE Analytic Engine", response = KeyObject.class, responseContainer = "List", tags={ "key", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Server response", response = KeyObject.class, responseContainer = "List"),
        @ApiResponse(code = 400, message = "Bad request", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = String.class) })
    @RequestMapping(value = "/fhe/trans/key/get/{RequestId}/dsa/{DSAId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<List<KeyObject>> getTransKey(@ApiParam(value = "",required=true) @PathVariable("RequestId") String requestId,@ApiParam(value = "",required=true) @PathVariable("DSAId") String dsAId);
}
